#! /bin/sh
# By Keven Tipping. Copyright 2004/2005.

# WARNING: If you don't know Linux, use & to run this script in the BACKGROUND (ie, set it running
# on its merry way without blocking up the terminal). So, to execute this and let it run in the
# background and not the foreground, run it as:
# sh ./sample.sh &
# The & will tell Linux to run it as a job in the background until it terminates.
# NOTE that this will still TERMINATE once you close the terminal. To truely run this thing
# in the background, no seatbelts provided, run it as:
# nohup sh ./sample.sh &
# nohup prevents the job from dying once you logout/close the terminal. & makes it run in the
# background, therefore sending the script off to wherever to do its thing as needed. This is the
# best way to run your script once its verified working and you don't want to have to deal with
# it running in the foreground.

# Sample fontzcontrol Shell Script. Repeats until you exit from the menu!
# For a real script, one would have it run in the background until the CFA631
# terminates the script presumably by a menu system or other.. Although, it
# goes without saying to try the script FIRST before you send it off
# to go play in the background...

# WARNING.. This script is meant to be, in NO WAY, simple or easy. You might be able to hack around
# and change things, but alas, it would be better if you actually understood the script so you
# could use things properly. I will do my best to document this script anyways. You could verywell 
# use this as a template for a larger more complicated script, if you know whats happening you
# could make a really complicated script. This script is timed, the display approx updates once
# a second in the main loops. You can turn this down, to update things quicker, or to maybe
# run a bargraph (not implemented YET), or change Bignumbers. Its all up to you. Once you know
# what you are doing in Bash, you can implement practically anything with the display.

# FC should be the path to FontzControl
FC=/home/keven/Projects/FontzControl/src/fontzcontrol
# Display the startup screen. Only shows ONCE.
$FC clear
$FC keydisable
$FC writetext 1 1 $0
$FC writetext 1 2 Sample SH Script
sleep 2
$FC clear
$FC keylegend 9 2 9 1
QUIT=0
CFKEY=0
CLOCK=0

# This is for the Menu Function. Note that it is MENUITEM#, where # is the number of the menu.
# In this case, it corresponds to menu1. The Menu titles are what displays as you scroll through
# them. MENUCOMMAND#[], where # is 1 for the function menu1, is the array that holds the commands
# that Bash executes when you push the execute button. In this case [4] holds the command that
# bash executes, exiting the menu and going back to the origenal screen. MENUCOMMAND can hold any
# amount of commands, where the array number MENUCOMMAND#[x], x corresponds to the command attached
# to the MENUITEM (the actual text). This command can do anything- call another function or menu,
# execute a shell command, etc.

# WARNING: Right now if you try to scroll the display to a MENUITEM that isn't there, this script
# will segfault and die... Relaunch it if you want. No harm should be done...

MENUITEM1[1]="Menu Item 1"
MENUITEM1[2]="Menu Item 2"
MENUITEM1[3]="Menu Item 3"
MENUITEM1[4]="Quit Menu"
MENUCOMMAND1[4]="EXITMENU=1"

# End of the Menu information

function menu1 {
	LINE1=1
	LINE2=2
	EXITMENU=0
	$FC keylegend 2 3 2 4
	while [ $EXITMENU -ne 1 ]; do
		$FC clear
		$FC writetext 1 1 ${MENUITEM1[$LINE1]}
		$FC writetext 1 2 ${MENUITEM1[$LINE2]}
		CFKEY=`$FC getkey 1 0`
		if [ $CFKEY -eq 2 ] ; then
			LINE1=$(echo "$LINE1-2" | bc)
			LINE2=$(echo "$LINE2-2" | bc)
		fi
		if [ $CFKEY -eq 4 ] ; then
			LINE1=$(echo "$LINE1+2" | bc)
			LINE2=$(echo "$LINE2+2" | bc)
		fi
		if [ $CFKEY -eq 3 ] ; then
			`echo typeset ${MENUCOMMAND1[$LINE2]}`
		fi
		if [ $CFKEY -eq 1 ] ; then
			`echo typeset ${MENUCOMMAND1[$LINE1]}`
		fi		
	done
	$FC keylegend 9 2 9 1
}

# This section consists of what is rotated through when the system is idling, or no menu
# is on the screen. Note how it works HERE, the main loop checks if Quit is 1. I don't actually use
# quit, but anyways, then the loop consists of two smaller loops that FIRST disply their
# information then use getkey from FontzControl as a 1 Second Timer. getkey waits for a second
# and then terminates, OR, terminates IF a key is pressed and returns that number.
# Each time through the loop, "Clock" is counting and since getkey is the timer, the loop will
# only execute 5 times in this case, and then the next WHILE loop executes (new screen).

while [ $QUIT -eq 0 ]; do
	$FC clear
	CLOCK=0
	while [  $CLOCK -lt 5 ]; do
		UPTIME=`uptime`
		UPTIME=${UPTIME:13:5}
		$FC writetext 1 1 Name: `uname -n`
		$FC writetext 1 2 Uptime: $UPTIME
		CFKEY=`$FC getkey 0 10000`
		# Simple key function, exit or show the menu.
		if [ $CFKEY -eq 4 ] ; then
			$FC clear
			$FC writetext 1 1 Goodbye!
			$FC keydisable
			exit
		elif [ $CFKEY -eq 2 ] ; then
			menu1
		fi
		CLOCK=$(echo "$CLOCK+1" | bc)
	done
	$FC clear
	CLOCK=0
	while [  $CLOCK -lt 5 ]; do
		IPADDY=`/sbin/ifconfig eth0`
		IPADDY=${IPADDY:78:8}
		$FC writetext 1 1 IP Address:
		$FC writetext 1 2 $IPADDY
		CFKEY=`$FC getkey 0 10000`
		if [ $CFKEY -eq 4 ] ; then
			$FC clear
			$FC writetext 1 1 Goodbye!
			$FC keydisable
			exit
		elif [ $CFKEY -eq 2 ] ; then
			menu1
		fi
		CLOCK=$(echo "$CLOCK+1" | bc)
	done
done
